<template>
    <v-container fluid>

        <v-card max-width="1200" class="ma-auto">

            <div class="text-h4 text-lg-h3 pa-7">Workers</div>
            <template>
                <v-data-table :headers="headers" :items="workers" :items-per-page="10" class="elevation-1">
                    <template v-slot:item.light.image="{ item }">
                        <v-avatar size="40">
                            <v-img v-if="item.light.image != ''" :src="item.light.image" alt="profile"/>
                        </v-avatar>
                    </template>

                    <template v-slot:item.light.trade="{ item }">
                        <div>
                            <v-chip v-for="trade in  item.light.trade" :key="trade" small class="ma-1">
                                {{ trade }}
                            </v-chip>
                        </div>

                    </template>

                    <template v-slot:item.actions="{ item }">
                        <IconLinks
                                icon="$vuetify.icons.footprint"
                                :to="{ path: `worker/${item.subContractor.id}/${item.light.id}` }"
                                tooltip="Movement History"
                                :button-props="{ color: 'white' }"
                        />
                    </template>

                </v-data-table>
            </template>
        </v-card>

    </v-container>
</template>

<style lang='scss' scoped>
    .controls {
        position: absolute;
        right: 0;
        bottom: 0;
    }
</style>

<script lang='ts'>
    import {Component} from "vue-property-decorator";
    import {Mixins} from "vue-mixin-decorator";
    import {Initializable} from "../../mixins/Initializable";
    import {Validable} from "../../mixins/Validable";
    import {coreApi} from "../../init";
    import {WorkerResponse} from "../../../../classLibrary/core/workerResponse";
    import IconLinks from "../../components/IconLinks.vue";

    interface AllWorkerMixin extends Initializable, Validable {
    }

    @Component({
        components: {IconLinks}
    })

    export default class AllWorker extends Mixins<AllWorkerMixin>(Initializable, Validable) {

        headers = [
            {text: '', value: 'light.image', align: 'center', width: '84px', sortable: false},
            {
                text: 'Name',
                align: 'start',
                value: 'light.name',
                width: '180px',
            },
            {text: 'Company', value: 'subContractor.name', width: '180px'},
            {
                text: 'Trade(s)',
                value: 'light.trade',
            },
            {text: '', value: 'actions', sortable: false}
        ];

        workers: WorkerResponse[] = [];

        // colors = ["aliceblue", "antiquewhite", "aquamarine", "azure", "bisque", "coral", "cornsilk", "darkorange"];
        // colorIndex = -1
        // tradeColors = {}

        // getTradeColor(trade: string) {
        //     if (this.tradeColors[trade]) {
        //         return this.tradeColors[trade];
        //     }
        //
        //     this.colorIndex += 1;
        //     if (this.colorIndex >= this.colors.length) {
        //         this.colorIndex = this.colorIndex % this.colors.length;
        //     }
        //
        //     const color = this.colors[this.colorIndex];
        //     this.tradeColors[trade] = color
        //
        //     return color
        // }

        async update() {
            const workersResult = await coreApi.Get<WorkerResponse[]>("Worker");
            if (workersResult.success) {
                this.workers = workersResult.Ok!;
            } else {
                this.err = workersResult.error!;
            }
        }

        async init() {
            await this.update()
        }

        async mountInit() {

        }
    }
</script>
